.model large
.486p

public _ScalePost,_ScaleLine

extrn _postsource:DWORD,_postx:WORD,_postwidth:WORD,_maxscaleshl2:WORD
extrn _wallheight:WORD,_fullscalefarcall,_shadetable
extrn _bufferofs:WORD,_mapmasks1,_mapmasks2,_mapmasks3
extrn _linescale:DWORD,_linecmds:DWORD,_slinex:WORD,_slinewidth:WORD
extrn _mask1:BYTE,_mask2:BYTE,_mask3:BYTE,_shade:BYTE
extrn _LSHADE_flag:WORD
extrn _viewheight:WORD

_DATA   segment word public use16 'DATA'
_DATA   ends
_BSS   segment word public use16 'BSS'
_BSS   ends

DGROUP   group   _DATA,_BSS

WL_DRAW_TEXT   segment byte public use16 'CODE'
   assume   cs:WL_DRAW_TEXT,ds:DGROUP

origstripe   db 64 dup (0)

_ScalePost   proc   near
   push   bp
   push   si
   push   di

   mov   bx,word ptr _postx
   mov   di,bx
   add   bx,bx
   mov   bp,word ptr [_wallheight+bx]
   and   bp,0fff8h
   shr   bp,1
   mov   bx,word ptr _maxscaleshl2
   cmp   bp,bx
   jle   heightok
   mov   bp,bx
heightok:

   shr   bx,8
   xor   dx,dx
   mov   ax,bp
   add   bx,word ptr _LSHADE_flag
   inc   bx
   div   bx                           

   or      al,al
   je      shadeclip
   cmp   al,31
   jbe   noshadeclip
   mov   al,31
   jmp   noshadeclip
shadeclip:
   mov   al,1
noshadeclip:
   neg   al
   add   al,32
   mov   bh,al

   push   ds
   push   fs
   mov   si,word ptr _postsource
   mov   ds,word ptr _postsource+2
   push   cs
   pop   es
   mov   di,offset cs:origstripe
   mov   ax,seg _shadetable
   mov   fs,ax
   mov   cl,64

shadeloop:
   mov   bl,[si]
   mov   al,byte ptr fs:[bx+offset _shadetable]
   inc   si
   mov   es:[di],al
   inc   di
   dec   cl
   jne   shadeloop
   pop   fs
   pop   ds


   mov   ax,0a000h
   mov   es,ax
   add   bp,offset _fullscalefarcall

   mov   bx,word ptr _postx
   mov   di,bx
   add   bx,bx
   shr   di,2
   add   di,word ptr _bufferofs
   and   bx,6
   shl   bx,2
   add   bx,word ptr _postwidth
   mov   al,byte ptr [_mapmasks1-1+bx]
   mov   dx,03c4h+1
   out   dx,al

   push   ds
   push   cs
   pop   ds
   mov   si,offset cs:origstripe

   call   dword ptr [bp]

   mov   al,byte ptr ss:[_mapmasks2-1+bx]
   or      al,al
   je      nomore

   inc   di
   out   dx,al
   call   dword ptr [bp]

   mov   al,byte ptr ss:[_mapmasks3-1+bx]
   or      al,al
   je      nomore

   inc   di
   out   dx,al
   call   dword ptr [bp]

nomore:

   pop   ds
   pop   di
   pop   si
   pop   bp
   ret
_ScalePost   endp

WL_DRAW_TEXT   ends


WL_SCALE_TEXT   segment byte public use16 'CODE'
   assume   cs:WL_SCALE_TEXT,ds:DGROUP

   ;
   ;   void near ScaleLine (void)
   ;

shadedcol   db   64 dup (0)

_ScaleLine   proc   near
   push   bp
   mov   bp,sp
   push   si
   push   di
   mov   al,byte ptr [_shade]
   mov   byte ptr cs:shadeval1,al
   mov   byte ptr cs:shadeval2,al
   mov   byte ptr cs:shadeval3,al
   mov   ax,seg _shadetable
   mov   fs,ax
   mov   cx,WORD PTR [_linescale+2]
   mov   es,cx                                  ; segment of scaler
   mov   bp,WORD PTR [_linecmds]
   mov   dx,03C4H+1                             ; SC_INDEX+1 to set SC_MAPMASK
   mov   bx,[_slinex]
   mov   di,bx
   shr   di,2                                   ; X in bytes
   add   di,[_bufferofs]
   and   bx,3
   shl   bx,3
   add   bx,[_slinewidth]                       ; bx = &mapmask3[slinex][slinewidth]-mapmask3
   mov   al,byte ptr [_mapmasks3-1+bx]       ; -1 because pixwidth of 1 is first
   mov   ds,word ptr [_linecmds+2]
   or      al,al
   je      short notthreebyte                     ; scale across three bytes
   jmp   threebyte
notthreebyte:
   mov   al,byte ptr ss:[_mapmasks2-1+bx]    ; -1 because pixwidth of 1 is first
   or      al,al
   jne   short twobyte                          ; scale across two bytes
   ;
   ;  one byte scaling
   ;
   mov   al,byte ptr ss:[_mapmasks1-1+bx]    ; -1 because pixwidth of 1 is first
   out   dx,al                                  ; set map mask register

scalesingle:
   mov   bx,[ds:bp]                             ; table location of rtl to patch
   or      bx,bx
   je      short linedone                         ; 0 signals end of segment list
   mov   bx,[es:bx]
   mov   dl,[es:bx]                             ; save old value
   mov   byte ptr es:[bx],0cbh                  ; patch a RETF in
   mov   si,[ds:bp+4]                           ; table location of entry spot
   mov   ax,[es:si]
   mov   word ptr ss:[_linescale],ax            ; call here to start scaling
   mov   si,[ds:bp+2]                  ; corrected top of shape for this segment
   add   bp,6                                   ; next segment list

   push   ds
   push   bx
   push   cs
   pop   es
   push   di
   mov   di,offset cs:shadedcol
   mov   ah,64
   mov   bh,12
shadeval1   equ $-1

spshadeloop1:
   mov   bl,[si]
   mov   al,byte ptr fs:[bx+offset _shadetable]
   inc   si
   mov   es:[di],al
   inc   di
   dec   ah
   jne   spshadeloop1
   pop   di
   pop   bx
   push   cs
   pop   ds
   mov   si,offset cs:shadedcol                   ; ds:si -> shadecol

   mov   ax,0a000h
   mov   es,ax
   call   ss:[_linescale]                        ; scale the segment of pixels
   pop   ds
   mov   es,cx                                  ; segment of scaler
   mov   byte ptr es:[bx],dl                    ; unpatch the RETF
   jmp   short scalesingle                      ; do the next segment

   ;
   ;  done
   ;
linedone:
   mov   ax,ss
   mov   ds,ax
   pop   di
   pop   si
   pop   bp
   ret

   ;
   ;  two byte scaling
   ;
twobyte:
   mov   ss:[DGROUP:_mask2],al
   mov   al,byte ptr ss:[_mapmasks1-1+bx]    ; -1 because pixwidth of 1 is first
   mov   ss:[DGROUP:_mask1],al

scaledouble:
   mov   bx,[ds:bp]                             ; table location of rtl to patch
   or      bx,bx
   je      short linedone                         ; 0 signals end of segment list
   mov   bx,[es:bx]
   mov   cl,[es:bx]                             ; save old value
   mov   byte ptr es:[bx],0cbh                  ; patch a RETF in
   mov   si,[ds:bp+4]                           ; table location of entry spot
   mov   ax,[es:si]
   mov   word ptr ss:[_linescale],ax            ; call here to start scaling
   mov   si,[ds:bp+2]                  ; corrected top of shape for this segment
   add   bp,6                                   ; next segment list

   push   ds
   push   bx
   push   cs
   pop   es
   push   di
   mov   di,offset cs:shadedcol
   mov   ah,64
   mov   bh,12
shadeval2   equ $-1

spshadeloop2:
   mov   bl,[si]
   mov   al,byte ptr fs:[bx+offset _shadetable]
   inc   si
   mov   es:[di],al
   inc   di
   dec   ah
   jne   spshadeloop2
   pop   di
   pop   bx
   push   cs
   pop   ds
   mov   si,offset cs:shadedcol                   ; ds:si -> shadecol

   mov   ax,0a000h
   mov   es,ax
   mov   al,ss:[DGROUP:_mask1]
   out   dx,al                                  ; set map mask register
   call   ss:[_linescale]                        ; scale the segment of pixels
   inc   di
   mov   al,ss:[DGROUP:_mask2]
   out   dx,al                                  ; set map mask register
   call   ss:[_linescale]                        ; scale the segment of pixels
   dec   di
   pop   ds
   mov   es,word ptr ss:[_linescale+2]          ; segment of scaler
   mov   byte ptr es:[bx],cl                    ; unpatch the RETF
   jmp   scaledouble                            ; do the next segment

   ;
   ;  done
   ;
linedone2:
   mov   ax,ss
   mov   ds,ax
   pop   di
   pop   si
   pop   bp
   ret

   ;
   ;   three byte scaling
   ;
threebyte:
   mov   ss:[DGROUP:_mask3],al
   mov   al,byte ptr ss:[_mapmasks2-1+bx]    ; -1 because pixwidth of 1 is first
   mov   ss:[DGROUP:_mask2],al
   mov   al,byte ptr ss:[_mapmasks1-1+bx]    ; -1 because pixwidth of 1 is first
   mov   ss:[DGROUP:_mask1],al

scaletriple:
   mov   bx,ds:[bp]                             ; table location of rtl to patch
   or      bx,bx
   je      short linedone2                        ; 0 signals end of segment list
   mov   bx,es:[bx]
   mov   cl,es:[bx]                             ; save old value
   mov   byte ptr es:[bx],0cbh                  ; patch a RETF in
   mov   si,ds:[bp+4]                           ; table location of entry spot
   mov   ax,es:[si]
   mov   word ptr ss:[_linescale],ax            ; call here to start scaling
   mov   si,ds:[bp+2]                  ; corrected top of shape for this segment
   add   bp,6                                   ; next segment list

   push   ds
   push   bx
   push   cs
   pop   es
   push   di
   mov   di,offset cs:shadedcol
   mov   ah,64
   mov   bh,12
shadeval3   equ $-1

spshadeloop3:
   mov   bl,[si]
   mov   al,byte ptr fs:[bx+offset _shadetable]
   inc   si
   mov   es:[di],al
   inc   di
   dec   ah
   jne   spshadeloop3
   pop   di
   pop   bx
   push   cs
   pop   ds
   mov   si,offset cs:shadedcol                   ; ds:si -> shadecol

   mov   ax,0a000h
   mov   es,ax
   mov   al,ss:[DGROUP:_mask1]
   out   dx,al                                  ; set map mask register
   call   ss:[_linescale]                        ; scale the segment of pixels
   inc   di
   mov   al,ss:[DGROUP:_mask2]
   out   dx,al                                  ; set map mask register
   call   ss:[_linescale]                        ; scale the segment of pixels
   inc   di
   mov   al,ss:[DGROUP:_mask3]
   out   dx,al                                  ; set map mask register
   call   ss:[_linescale]                        ; scale the segment of pixels
   dec   di
   dec   di
   pop   ds
   mov   es,word ptr ss:[_linescale+2]          ; segment of scaler
   mov   byte ptr es:[bx],cl                     ; unpatch the RETF
   jmp   scaletriple                            ; do the next segment

_ScaleLine   endp

WL_SCALE_TEXT   ends

end

